#ifndef object_h
#define object_h

#include <boost/intrusive_ptr.hpp>


// boost::intrusive_ptr p̃t@XJE^ 
class Object
{
private:
  size_t m_ref;

public:
  Object() : m_ref(0) {}
  virtual ~Object() {}
  void addRef() { ++m_ref; }
  void release() {
    if(--m_ref==0) {
      delete this;
    }
  }
};
inline void intrusive_ptr_add_ref(Object *p) { p->addRef(); }
inline void intrusive_ptr_release(Object *p) { p->release(); }

#endif
